/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.basis.heldio;

import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.*;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ATTACKE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BASISSTUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BASISWERT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_BONUS;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_EIGENSCHAFT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SONDERFERTIGKEIT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_SPEZIELLE_ERFAHRUNG;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_STUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_TALENT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_UNMODIFIZIERTE_STUFE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_VARIANTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_VOR_NACHTEIL;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.ATTR_ZUKAUF;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ALTER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_AUGENFARBE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_AUSSEHEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_BASISWERT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_EIGENSCHAFT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_EINGESETZTE_AP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GEBURTSTAG;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GESAMT_AP;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GESCHLECHT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GEWICHT;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_GROESSE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HAARFARBE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HAUSZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_HINTERGRUND;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_KULTUR;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_LEITTALENTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_LEITZAUBER;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_MUTTERSPRACHE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_NAME;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_PROFESSION;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_RASSE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_SONDERFERTIGKEIT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_STAND;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TALENT_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_TITEL;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VERBILLIGTE_SONDERFERTIGKEITEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VERBILLIGTE_VARIANTEN;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_VOR_NACHTEIL_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZAUBER_WERTE;
import static de.bernhardjung.dsaprogramm.basis.heldio.HeldXmlTags.TAG_ZWEITSPRACHE;

import java.util.ArrayList;
import java.util.List;

import net.n3.nanoxml.IXMLElement;
import de.bernhardjung.dsaprogramm.basis.Augenfarbe;
import de.bernhardjung.dsaprogramm.basis.FernkampfwaffeWert;
import de.bernhardjung.dsaprogramm.basis.Haarfarbe;
import de.bernhardjung.dsaprogramm.basis.Held;
import de.bernhardjung.dsaprogramm.basis.Kulturkunde;
import de.bernhardjung.dsaprogramm.basis.NahkampfwaffeWert;
import de.bernhardjung.dsaprogramm.basis.RuestungWert;
import de.bernhardjung.dsaprogramm.basis.SchildTyp;
import de.bernhardjung.dsaprogramm.basis.SchildWert;
import de.bernhardjung.dsaprogramm.basis.Tp;
import de.bernhardjung.dsaprogramm.basiswerte.Basiswert;
import de.bernhardjung.dsaprogramm.basiswerte.BasiswertWert;
import de.bernhardjung.dsaprogramm.bausteine.Kultur;
import de.bernhardjung.dsaprogramm.bausteine.Profession;
import de.bernhardjung.dsaprogramm.bausteine.Rasse;
import de.bernhardjung.dsaprogramm.bausteine.util.Geschlecht;
import de.bernhardjung.dsaprogramm.daten.Datenspeicher;
import de.bernhardjung.dsaprogramm.eigenschaften.Eigenschaft;
import de.bernhardjung.dsaprogramm.eigenschaften.EigenschaftWert;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.Sonderfertigkeit;
import de.bernhardjung.dsaprogramm.sonderfertigkeiten.SonderfertigkeitWert;
import de.bernhardjung.dsaprogramm.talente.Kampftechnik;
import de.bernhardjung.dsaprogramm.talente.Sprache;
import de.bernhardjung.dsaprogramm.talente.Talent;
import de.bernhardjung.dsaprogramm.talente.TalentWert;
import de.bernhardjung.dsaprogramm.talente.Talentgruppe;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteil;
import de.bernhardjung.dsaprogramm.vornachteile.VorNachteilWert;
import de.bernhardjung.dsaprogramm.zauber.Repraesentation;
import de.bernhardjung.dsaprogramm.zauber.Zauber;
import de.bernhardjung.dsaprogramm.zauber.ZauberWert;

public class FactoryHeldXmlIn {

    private final Datenspeicher speicher = Datenspeicher.getInstanz();

    /**
     * Ermittelt die Augenfarbe des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Augenfarbe des Helden.
     */
    private final String ermitteleAugenfarbe( final IXMLElement wurzelElement ) {

        String augenfarbe =
            wurzelElement.getFirstChildNamed( TAG_AUGENFARBE ).getContent();

        if ( Augenfarbe.hatAugenfarbe( augenfarbe ) ) {

            augenfarbe = Augenfarbe.getAugenfarbe( augenfarbe );
        }

        return augenfarbe;
    }

    /**
     * Ermittelt die Fernkampfwaffen des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Fernkampfwaffen, die der Held mit sich fuehrt.
     */
    private final List< FernkampfwaffeWert > ermitteleFernkampfwaffen(
            final IXMLElement wurzelElement ) {

        final List< FernkampfwaffeWert > waffen =
            new ArrayList< FernkampfwaffeWert >();

        final IXMLElement waffenElement =
            wurzelElement.getFirstChildNamed( TAG_FERNKAMPFWAFFE_WERTE );

        if ( null == waffenElement ) {
            // nichts zu tun.
            return waffen;
        }

        for ( final IXMLElement waffeElement :
            waffenElement.getChildren() ) {

            final String waffenId =
                waffeElement.getAttribute( ATTR_FERNKAMPFWAFFE );

            final FernkampfwaffeWert waffe =
                new FernkampfwaffeWert( speicher.getFernkampfwaffe( waffenId ));

            waffe.setName( waffeElement.getAttribute( ATTR_NAME ) );

            final String reichweiten =
                waffeElement.getAttribute( ATTR_REICHWEITEN );

            waffe.setReichweiten( toIntegerListe( reichweiten ) );

            if ( waffeElement.hasAttribute( ATTR_TALENT  ) ) {

                final String talentId =
                    waffeElement.getAttribute( ATTR_TALENT );

                waffe.setTalent( (Kampftechnik) Talent.getTalent( talentId ) );
            }

            waffe.setTp( new Tp( waffeElement.getAttribute( ATTR_TP ) ) );

            final String tpPlus =
                waffeElement.getAttribute( ATTR_TP_PLUS );

            waffe.setTpPlus( toIntegerListe( tpPlus ) );

            waffen.add( waffe );
        }

        return waffen;
    }

    /**
     * Ermittelt das Geschlecht des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return das Geschlecht des Helden/der Heldin.
     */
    private final Geschlecht ermitteleGeschlecht( final IXMLElement wurzelElement ){

        final String name =
            wurzelElement.getFirstChildNamed( TAG_GESCHLECHT ).getContent();

        return Geschlecht.valueOf( name );
    }

    /**
     * Ermittelt die Haarfarbe des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Haarfarbe des Helden.
     */
    private final String ermitteleHaarfarbe( final IXMLElement wurzelElement ) {

        String haarfarbe =
            wurzelElement.getFirstChildNamed( TAG_HAARFARBE ).getContent();

        if ( Haarfarbe.hatHaarfarbe( haarfarbe ) ) {

            haarfarbe = Haarfarbe.getHaarfarbe( haarfarbe );
        }

        return haarfarbe;
    }

    /**
     * Ermittelt die Hauszauber aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Hauszauber des Held. Wenn der Held keine HAuszauber hat ist
     *         die Liste leer.
     */
    private final List< Zauber > ermitteleHauszauber(
            final IXMLElement wurzelElement ) {

        final List< Zauber > hauszauber = new ArrayList< Zauber >();

        final IXMLElement hauszauberElement =
            wurzelElement.getFirstChildNamed( TAG_HAUSZAUBER );

        if ( null != hauszauberElement ) {

            for ( final IXMLElement talentElement :
                hauszauberElement.getChildren() ) {

                final String id = talentElement.getContent();

                hauszauber.add( Zauber.getZauber( id ) );
            }
        }

        return hauszauber;
    }

    /**
     * Ermittelt die Kultur des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Kultur des Helden.
     */
    private final Kultur ermitteleKultur( final IXMLElement wurzelElement ) {

        final String id =
            wurzelElement.getFirstChildNamed( TAG_KULTUR ).getContent();

        return Datenspeicher.getInstanz().getKultur( id );
    }

    /**
     * Ermittelt die Leittalente aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Leittalente des Held. Wenn der Held keine Leittalente hat ist
     *         die Liste leer.
     */
    private final List< Talent > ermitteleLeittalente(
            final IXMLElement wurzelElement ) {

        final List< Talent > leittalente = new ArrayList< Talent >();

        final IXMLElement leittalenteElement =
            wurzelElement.getFirstChildNamed( TAG_LEITTALENTE );

        if ( null != leittalenteElement ) {

            for ( final IXMLElement talentElement :
                leittalenteElement.getChildren() ) {

                final String id = talentElement.getContent();

                leittalente.add( Talent.getTalent( id ) );
            }
        }

        return leittalente;
    }

    /**
     * Ermittelt die Leitzauber aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Leitzauber des Held. Wenn der Held keine Leitzauber hat ist
     *         die Liste leer.
     */
    private final List< Zauber > ermitteleLeitzauber(
            final IXMLElement wurzelElement ) {

        final List< Zauber > leitzauber = new ArrayList< Zauber >();

        final IXMLElement leitzauberElement =
            wurzelElement.getFirstChildNamed( TAG_LEITZAUBER );

        if ( null != leitzauberElement ) {

            for ( final IXMLElement talentElement :
                leitzauberElement.getChildren() ) {

                final String id = talentElement.getContent();

                leitzauber.add( Zauber.getZauber( id ) );
            }
        }

        return leitzauber;
    }

    /**
     * Ermittelt die Muttersprache des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Muttersprache des Helden.
     */
    private final Sprache ermitteleMuttersprache( final IXMLElement wurzelElement ) {

        final String id = getTagInhalt( TAG_MUTTERSPRACHE, wurzelElement );

        return (Sprache) Talent.getTalent( id );
    }

    /**
     * Ermittelt die Nahkampfwaffen des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Nahkampfwaffen des Helden.
     */
    private final List< NahkampfwaffeWert > ermitteleNahkampfwaffen(
            final IXMLElement wurzelElement ) {

        final List< NahkampfwaffeWert > waffen =
            new ArrayList< NahkampfwaffeWert >();

        final IXMLElement waffenElement =
            wurzelElement.getFirstChildNamed( TAG_NAHKAMPFWAFFE_WERTE );

        if ( null == waffenElement ) {
            // nichts zu tun.
            return waffen;
        }

        for ( final IXMLElement waffeElement : waffenElement.getChildren() ) {

            final String waffenId =
                waffeElement.getAttribute( ATTR_NAHKAMPFWAFFE );

            final NahkampfwaffeWert waffe =
                new NahkampfwaffeWert( speicher.getNahkampfwaffe( waffenId ) );

            waffe.setBf( getAttributInt( waffeElement, ATTR_BF ) );

            waffe.setDkH( getAttributBoolean( waffeElement, ATTR_DK_H ) );

            waffe.setDkN( getAttributBoolean( waffeElement, ATTR_DK_N ) );

            waffe.setDkS( getAttributBoolean( waffeElement, ATTR_DK_S ) );

            waffe.setIni( getAttributInt( waffeElement, ATTR_INI ) );

            waffe.setName( waffeElement.getAttribute( ATTR_NAME ) );

            waffe.setSchadensschritt(
                    getAttributInt( waffeElement, ATTR_SCHADENSSCHRITT ) );

            waffe.setSchwellenwert(
                    getAttributInt( waffeElement, ATTR_SCHWELLENWERT ) );

            final String talentId = waffeElement.getAttribute( ATTR_TALENT );

            waffe.setTalent( (Kampftechnik) Talent.getTalent( talentId ) );

            waffe.setTp( new Tp( waffeElement.getAttribute( ATTR_TP ) ) );

            waffe.setWmAt( getAttributInt( waffeElement, ATTR_WM_AT ) );

            waffe.setWmPa( getAttributInt( waffeElement, ATTR_WM_PA ) );

            waffen.add( waffe );
        }

        return waffen;
    }

    /**
     * Ermittelt die Profession des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Profession des Helden.
     */
    private final Profession ermitteleProfession( final IXMLElement wurzelElement ){

        final String id =
            wurzelElement.getFirstChildNamed( TAG_PROFESSION ).getContent();

        return Datenspeicher.getInstanz().getProfession( id );
    }

    /**
     * Ermittelt die Rasse des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Rasse des Helden.
     */
    private final Rasse ermitteleRasse( final IXMLElement wurzelElement ) {

        final String id =
            wurzelElement.getFirstChildNamed( TAG_RASSE ).getContent();

        return Datenspeicher.getInstanz().getRasse( id );
    }

    /**
     * Ermittelt die Ruestungen, die der Held traegt, aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Ruestungen des Helden.
     */
    private List< RuestungWert > ermitteleRuestungen(
            final IXMLElement wurzelElement ) {

        final List< RuestungWert > ruestungen =
            new ArrayList< RuestungWert >();

        final IXMLElement ruestungenElement =
            wurzelElement.getFirstChildNamed( TAG_RUESTUNG_WERTE );

        if ( null == ruestungenElement ) {
            // nichts zu tun.
            return ruestungen;
        }

        for ( final IXMLElement ruestungElement :
            ruestungenElement.getChildren() ) {

            final String ruestungsId =
                ruestungElement.getAttribute( ATTR_RUESTUNG );

            final RuestungWert ruestung =
                new RuestungWert( speicher.getRuestung( ruestungsId ) );

            ruestung.setBe( getAttributInt( ruestungElement, ATTR_BE ) );

            ruestung.setName( ruestungElement.getAttribute( ATTR_NAME ) );

            ruestung.setRs( getAttributInt( ruestungElement, ATTR_RS ) );

            ruestungen.add( ruestung );
        }

        return ruestungen;
    }

    /**
     * Ermittelt die Schilde, die der Held mit sich traegt, aus dem
     * XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Schilde des Helden.
     */
    private List< SchildWert > ermitteleSchilde(
            final IXMLElement wurzelElement ) {

        final List< SchildWert > schilde =
            new ArrayList< SchildWert >();

        final IXMLElement schildeElement =
            wurzelElement.getFirstChildNamed( TAG_SCHILD_WERTE );

        if ( null == schildeElement ) {
            // nichts zu tun.
            return schilde;
        }

        for ( final IXMLElement schildElement :
            schildeElement.getChildren() ) {

            final String schildId =
                schildElement.getAttribute( ATTR_SCHILD );

            final SchildWert schild =
                new SchildWert( speicher.getSchild( schildId ) );

            schild.setBf( getAttributInt( schildElement, ATTR_BF ) );

            schild.setIni( getAttributInt( schildElement, ATTR_INI ) );

            schild.setName( schildElement.getAttribute( ATTR_NAME ) );

            final String typId = schildElement.getAttribute( ATTR_TYP );

            schild.setTyp( SchildTyp.getTyp( typId ) );

            schild.setWmAt( getAttributInt( schildElement, ATTR_WM_AT ) );

            schild.setWmPa( getAttributInt( schildElement, ATTR_WM_PA ) );

            schilde.add( schild );
        }

        return schilde;
    }

    /**
     * Ermittelt eine Sonderfertigkeit aus einem XML-IXMLElement.
     *
     * @param sfElement
     *            das IXMLElement, das die Sonderfertigkeit repraesentiert.
     * @return eine Sonderfertigkeit.
     */
    private final Sonderfertigkeit ermitteleSonderfertigkeit(
            final IXMLElement sfElement ) {

        final String id =
            sfElement.getAttribute( ATTR_SONDERFERTIGKEIT );

        final Sonderfertigkeit sf;

        if ( id.equals( Sonderfertigkeit.ID_SCHARFSCHUETZE ) ) {

            final String talentId = sfElement.getAttribute( ATTR_TALENT );

            final Talent talent = Talent.getTalent( talentId );

            sf = Sonderfertigkeit.getScharfschuetze( (Kampftechnik) talent );

        } else if ( id.equals( Sonderfertigkeit.ID_TALENTSPEZIALISIERUNG ) ) {

            final String talentId = sfElement.getAttribute( ATTR_TALENT );

            final Talent talent = Talent.getTalent( talentId );

            sf = Sonderfertigkeit.getTalentspezialisierung( talent );

        } else if ( id.equals ( Sonderfertigkeit.ID_WAFFENSPEZIALISIERUNG ) ) {

            final String talentId = sfElement.getAttribute( ATTR_TALENT );

            final Talent talent = Talent.getTalent( talentId );

            sf = Sonderfertigkeit.getWaffenspezialisierung(
                    (Kampftechnik) talent );
        } else {

            sf = Sonderfertigkeit.getSonderfertigkeit( id );
        }

        return sf;
    }

    private final List< SonderfertigkeitWert > ermitteleSonderfertigkeiten(
            final IXMLElement wurzelElement ) {

        final List< SonderfertigkeitWert > werte =
            new ArrayList< SonderfertigkeitWert >();

        final IXMLElement werteElement =
            wurzelElement.getFirstChildNamed( TAG_SONDERFERTIGKEIT_WERTE );

        if ( null != werteElement ) {

            for ( final IXMLElement wertElement :
                werteElement.getChildren() ) {

                werte.add( erzeugeSonderfertigkeitWert( wertElement ) );
            }
        }

        return werte;
    }
    /**
     * Ermittelt die Talentwerte aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Talentwerte des Helden.
     */
    private final List< TalentWert > ermitteleTalentwerte(
            final IXMLElement wurzelElement ) {

        final List< TalentWert > werte = new ArrayList< TalentWert >();

        final IXMLElement werteElement =
            wurzelElement.getFirstChildNamed( TAG_TALENT_WERTE );

        for ( final IXMLElement wertElement : werteElement.getChildren() ) {

            final String id = wertElement.getAttribute( ATTR_TALENT );

            final Talent talent = Talent.getTalent( id );

            final int stufe =
                getAttributInt( wertElement, ATTR_UNMODIFIZIERTE_STUFE );

            final TalentWert wert = new TalentWert( talent, stufe );

            final boolean spezielleErfahrung =
                getAttributBoolean( wertElement, ATTR_SPEZIELLE_ERFAHRUNG );

            wert.setSpezielleErfahrung( spezielleErfahrung );

            final String aktiviertString =
                wertElement.getAttribute( ATTR_AKTIVIERT );

            if ( null != aktiviertString ) {

                wert.setAktiviert( Boolean.valueOf( aktiviertString ) );
            }

            final String attackeString =
                wertElement.getAttribute( ATTR_ATTACKE );

            if ( null != attackeString ) {

                wert.setAttacke( Integer.valueOf( attackeString ) );
            }

            werte.add( wert );
        }

        return werte;
    }

    /**
     * Ermittelt die verbilligten Sonderfertigkeiten aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die verbilligten Sonderfertigkeiten. Wenn der Held keine
     *         verbilligten Sonderfertigkeiten hat, so ist die Liste leer.
     */
    private final
    List< Sonderfertigkeit > ermitteleVerbilligteSonderfertigkeiten(
            final IXMLElement wurzelElement ) {

        final List< Sonderfertigkeit > verbilligte =
            new ArrayList< Sonderfertigkeit >();

        final IXMLElement sfenElement =
            wurzelElement.getFirstChildNamed(
                    TAG_VERBILLIGTE_SONDERFERTIGKEITEN );

        if ( null != sfenElement ) {

            for ( final IXMLElement sfElement : sfenElement.getChildren() ) {

                verbilligte.add(
                    ermitteleSonderfertigkeit( sfElement ) );

            }
        }

        return verbilligte;
    }

    /**
     * Ermittelt die Sonderfertigkeiten, von denen eine Variante verbilligt ist,
     * aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return Die verbilligten Varianten des Helden. Wenn der Held keine
     *         Varianten von Sonderfertigkeiten verbilligt bekommt, so ist die
     *         Liste leer.
     */
    private final
    List< SonderfertigkeitWert > ermitteleVerbilligteVarianten(
            final IXMLElement wurzelElement ) {

        final List< SonderfertigkeitWert > varianten =
            new ArrayList< SonderfertigkeitWert >();

        final IXMLElement variantenElement =
            wurzelElement.getFirstChildNamed( TAG_VERBILLIGTE_VARIANTEN );

        if ( null != variantenElement ) {

            for ( final IXMLElement wertElement :
                variantenElement.getChildren() ) {

                varianten.add(
                        erzeugeSonderfertigkeitWert( wertElement ) );
            }
        }

        return varianten;
    }

    /**
     * Ermittelt die Vor-/Nachteile aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return eine Liste mit den Vor-/Nachteilen des Helden. Wenn der Held
     *         keine Vor-/Nachteile hat, so ist die Liste leer.
     */
    private final List< VorNachteilWert > ermitteleVorNachteile(
            final IXMLElement wurzelElement ) {

        final List< VorNachteilWert > werte =
            new ArrayList< VorNachteilWert >();

        final IXMLElement werteElement =
            wurzelElement.getFirstChildNamed( TAG_VOR_NACHTEIL_WERTE );

        if ( null != werteElement ) {

            for ( final IXMLElement wertElement : werteElement.getChildren() ){

                werte.add( erzeugeVorNachteilWert( wertElement ) );
            }
        }

        return werte;
    }

    /**
     * Ermittelt die Zauber des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return Eine Liste der Zauber des Helden. Die Liste ist leer, wenn der
     *         Held keine Zauber beherrscht.
     */
    private final List< ZauberWert > ermitteleZauber(
            final IXMLElement wurzelElement ) {

        final List< ZauberWert > werte = new ArrayList< ZauberWert >();

        final IXMLElement zauberElement =
            wurzelElement.getFirstChildNamed( TAG_ZAUBER_WERTE );

        if ( null != zauberElement ) {

            for ( final IXMLElement element : zauberElement.getChildren() ) {

                final String id = element.getAttribute( ATTR_ZAUBER );

                final Zauber zauber = Zauber.getZauber( id );

                final int stufe = getAttributInt( element, ATTR_STUFE );

                final Object variante =
                    element.getAttribute( ATTR_VARIANTE );

                final ZauberWert wert;

                if ( null == variante ) {

                    wert = new ZauberWert( zauber, stufe );

                } else {

                    wert = new ZauberWert( zauber, variante, stufe );
                }

                final boolean spezielleErfahrung =
                    getAttributBoolean( element, ATTR_SPEZIELLE_ERFAHRUNG );

                wert.setSpezielleErfahrung( spezielleErfahrung );

                werte.add( wert );
            }

        }

        return werte;
    }

    /**
     * Ermittelt die Zweitsprache des Helden aus dem XML-Dokument.
     *
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return die Zweitsprache des Helden oder {@code null}, wenn der Held
     *         keine Zweitsprache beherrscht.
     */
    private final Sprache ermitteleZweitsprache( final IXMLElement wurzelElement ) {

        final String id = getTagInhalt( TAG_ZWEITSPRACHE, wurzelElement );

        if ( null != id ) {

            return (Sprache) Talent.getTalent( id );

        } else {

            return null;

        }

    }

    /**
     * Wandelt ein XML-Dokument in einen Helden um.
     *
     * @param wurzelElement
     *            Des XML-Dokuments.
     * @return den erzeugten Helden.
     */
    public final Held erzeugen( final IXMLElement wurzelElement ) {

        final Held held = new Held();

        // wirdErschaffen auf false setzen muss vor dem Einfuegen von Werten
        // geschehen, da die Methoden sich dann anders verhalten.
        // Beim Einfuegen von Vor-/Nachteilen arbeiten die Anpasser anders, bzw.
        // nicht mehr.
        held.setWirdErschaffen( false );

        held.setName( getTagInhalt( TAG_NAME, wurzelElement ) );

        // Die Rasse muss vor solchen Sachen wie Haarfarbe gesetzt werden, da
        // diese Dinge beim setzen der Rasse, entsprechend der Rasse,
        // aktualisiert werden.
        held.setRasse( ermitteleRasse( wurzelElement ) );

        held.setKultur( ermitteleKultur( wurzelElement ) );

        held.setProfession( ermitteleProfession( wurzelElement ) );

        held.setGeschlecht( ermitteleGeschlecht( wurzelElement ) );

        held.setGeburtstag( getTagInhalt( TAG_GEBURTSTAG, wurzelElement ) );

        held.setAlter( getTagInhaltInt( TAG_ALTER, wurzelElement ) );

        held.setGroesse( getTagInhaltInt( TAG_GROESSE, wurzelElement ) );

        held.setGewicht( getTagInhaltInt( TAG_GEWICHT, wurzelElement ) );

        held.setHaarfarbe( ermitteleHaarfarbe( wurzelElement ) );

        held.setAugenfarbe( ermitteleAugenfarbe( wurzelElement ) );

        held.setAussehen( getTagInhalt( TAG_AUSSEHEN, wurzelElement ) );

        held.setStand( getTagInhalt( TAG_STAND, wurzelElement ) );

        held.setTitel( getTagInhalt( TAG_TITEL, wurzelElement ) );

        held.setHintergrund( getTagInhalt( TAG_HINTERGRUND, wurzelElement ) );

        held.setApGesamt( getTagInhaltInt( TAG_GESAMT_AP, wurzelElement ) );

        held.setApEingesetzt( getTagInhaltInt( TAG_EINGESETZTE_AP,
                                               wurzelElement ) );

        setEigenschaften( held, wurzelElement );

        setBasiswerte( held, wurzelElement );

        held.setMuttersprache( ermitteleMuttersprache( wurzelElement ) );

        final Sprache zweitsprache = ermitteleZweitsprache( wurzelElement );

        if ( null != zweitsprache ) {

            held.setZweitsprache( zweitsprache );
        }

        for ( final TalentWert wert : ermitteleTalentwerte( wurzelElement ) ) {

            held.einfuegenVorgegeben( wert );
        }

        held.einfuegenLeittalente( ermitteleLeittalente( wurzelElement ) );

        for ( final ZauberWert wert : ermitteleZauber( wurzelElement ) ) {

            held.einfuegenVorgegeben( wert );
        }

        held.einfuegenHauszauber( ermitteleHauszauber( wurzelElement ) );

        held.einfuegenLeitzauber( ermitteleLeitzauber( wurzelElement ) );

        for ( final SonderfertigkeitWert wert :
            ermitteleSonderfertigkeiten( wurzelElement ) ) {

            held.einfuegenVorgegeben( wert );
        }

        for ( final Sonderfertigkeit sonderfertigkeit :
            ermitteleVerbilligteSonderfertigkeiten( wurzelElement ) ) {

            held.einfuegenVerbilligt( sonderfertigkeit );
        }

        for ( final SonderfertigkeitWert wert :
            ermitteleVerbilligteVarianten( wurzelElement ) ) {

            held.einfuegenVerbilligt( wert );
        }

        for ( final VorNachteilWert wert :
            ermitteleVorNachteile( wurzelElement ) ) {

            held.einfuegenVorgegeben( wert );
        }

        for ( final NahkampfwaffeWert waffe :
            ermitteleNahkampfwaffen( wurzelElement ) ) {

            held.einfuegen( waffe );
        }

        for ( final FernkampfwaffeWert waffe :
            ermitteleFernkampfwaffen( wurzelElement ) ) {

            held.einfuegen( waffe );
        }

        for ( final RuestungWert ruestung :
            ermitteleRuestungen( wurzelElement ) ) {

            held.einfuegen( ruestung );
        }

        for ( final SchildWert schild : ermitteleSchilde( wurzelElement ) ) {

            held.einfuegen( schild );
        }

        return held;
    }

    /**
     * Erzeugt eine Sonderfertigkeit aus einem IXMLElement des XML-Dokuments.
     *
     * @param wertElement
     *            Das IXMLElement, das den Wert repraesentiert.
     * @return der aus dem IXMLElement ermittelte Wert.
     */
    private final SonderfertigkeitWert erzeugeSonderfertigkeitWert(
            final IXMLElement wertElement ) {

        final Sonderfertigkeit sonderfertigkeit =
            ermitteleSonderfertigkeit( wertElement );

        final SonderfertigkeitWert wert;

        if ( sonderfertigkeit.hatVarianten() ) {

            final String varianteString =
                wertElement.getAttribute( ATTR_VARIANTE );

            final Object variante;

            if ( varianteString.startsWith( "Kulturkunde." ) ) {

                variante = Kulturkunde.getKulturkunde( varianteString );

            } else if ( varianteString.startsWith( "Repraesentation." ) ) {

                variante = Repraesentation.getRepraesentation( varianteString );

            } else {

                variante = varianteString;
            }

            wert = new SonderfertigkeitWert( sonderfertigkeit, variante );

        } else {

            wert = new SonderfertigkeitWert( sonderfertigkeit );
        }

        return wert;
    }

    /**
     * Erzeugt einen Vor-/Nachteil aus einem IXMLElement des XML-Dokuments.
     *
     * @param wertElement
     *            Das IXMLElement, das den Wert repraesentiert.
     * @return der aus dem IXMLElement ermittelte Wert.
     */
    private final VorNachteilWert erzeugeVorNachteilWert(
            final IXMLElement wertElement ) {

        final String id = wertElement.getAttribute( ATTR_VOR_NACHTEIL );

        final VorNachteil vorNachteil = VorNachteil.getVorNachteil( id );

        final VorNachteilWert wert;

        if ( vorNachteil.hatVarianten() ) {

            final String varianteString =
                wertElement.getAttribute( ATTR_VARIANTE );

            final Object variante;

            if ( varianteString.startsWith( "Talentgruppe." ) ) {

                variante = Talentgruppe.getTalentgruppe( varianteString );

            } else if ( varianteString.startsWith( "Talent." ) ) {

                variante = Talent.getTalent( varianteString );

            }  else if ( varianteString.startsWith( "Zauber." ) ) {

                variante = Zauber.getZauber( varianteString );

            } else {

                variante = varianteString;
            }

            wert = new VorNachteilWert( vorNachteil, variante );

        } else {

            wert = new VorNachteilWert( vorNachteil );
        }

        final String stufeString =
            wertElement.getAttribute( ATTR_STUFE );

        if ( null != stufeString ) {

            wert.setStufe( Integer.valueOf( stufeString ) );
        }

        final String spezielleErfahrung =
            wertElement.getAttribute( ATTR_SPEZIELLE_ERFAHRUNG );

        if ( null != spezielleErfahrung ) {

            wert.setSpezielleErfahrung( Boolean.valueOf( spezielleErfahrung ) );
        }

        return wert;
    }

    /**
     * Liest eine Attribut-Wert aus, der einen Boolean-Wert enthaelt.
     *
     * @param element
     *            dessen Attribut ausgelesen werden soll.
     * @param attribut
     *            das ausgelesen werden soll.
     * @return den Wert des Attributs.
     */
    private final boolean getAttributBoolean(
            final IXMLElement element,
            final String attribut ) {

        final String wert = element.getAttribute( attribut );

        return Boolean.valueOf( wert );
    }

    /**
     * Liest eine Attribut-Wert aus, der einen Int-Wert enthaelt.
     *
     * @param element
     *            dessen Attribut ausgelesen werden soll.
     * @param attribut
     *            das ausgelesen werden soll.
     * @return den Wert des Attributs.
     */
    private final int getAttributInt(
            final IXMLElement element,
            final String attribut ) {

        final String wert = element.getAttribute( attribut );

        return Integer.valueOf( wert );
    }

    /**
     * Liefert den Textinhalt eines Elements des XML-Datei.
     *
     * @param tagName
     *            Der Name des Tags dessen Inhalt gesucht ist.
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return Den Inhalt des ersten Vorkommens des Elements {@code tag} im
     *         XML-Dokument. {@code null}, wenn das Tag nicht vor kommt.
     */
    private final String getTagInhalt(
            final String tagName,
            final IXMLElement wurzelElement ) {

        final IXMLElement tag = wurzelElement.getFirstChildNamed( tagName );

        if ( null != tag ) {

            String content = tag.getContent();

            if ( null == content ) {

                content = "";
            }

            return content;

        } else {
            return null;
        }
    }

    /**
     * Liefert den Inhalt eines Elements des XML-Datei, der aus einem
     * Integer-Wert besteht.
     *
     * @param tag
     *            dessen Inhalt gesucht ist.
     * @param wurzelElement
     *            des XML-Dokuments.
     * @return Den Inhalt des ersten Vorkommens des Elements {@code tag} im
     *         XML-Dokument.
     */
    private final int getTagInhaltInt(
            final String tag,
            final IXMLElement wurzelElement ) {

        return Integer.valueOf( getTagInhalt( tag, wurzelElement ) );
    }

    /**
     * Stellt die Basiswerte des Helden ein.
     *
     * @param held
     *            dessen Werte ermittelt werden.
     * @param wurzelElement
     *            des XML-Dokuments aus dem die Daten gelesen werden.
     */
    private final void setBasiswerte(
            final Held held,
            final IXMLElement wurzelElement ) {

        final IXMLElement werteElement =
            wurzelElement.getFirstChildNamed( TAG_BASISWERT_WERTE );

        for ( final IXMLElement wertElement : werteElement.getChildren() ) {

            final String id = wertElement.getAttribute( ATTR_BASISWERT );

            final Basiswert basiswert = Basiswert.getBasiswert( id );

            final BasiswertWert wert = held.getWert( basiswert );

            wert.setBonus( getAttributInt( wertElement, ATTR_BONUS ) );

            wert.setZukaufVorgegeben( getAttributInt(wertElement, ATTR_ZUKAUF));

            wert.setSpezielleErfahrung( getAttributBoolean(
                    wertElement, ATTR_SPEZIELLE_ERFAHRUNG ) );
        }
    }

    /**
     * Stellt die Eigenschaftswerte des Helden ein.
     *
     * @param held
     *            dessen Werte ermittelt werden.
     * @param wurzelElement
     *            des XML-Dokuments aus dem die Daten gelesen werden.
     */
    private final void setEigenschaften(
            final Held held,
            final IXMLElement wurzelElement ) {

        final IXMLElement werteElement =
            wurzelElement.getFirstChildNamed( TAG_EIGENSCHAFT_WERTE );

        for ( final IXMLElement wertElement : werteElement.getChildren() ) {

            final String id = wertElement.getAttribute( ATTR_EIGENSCHAFT );

            final Eigenschaft eigenschaft = Eigenschaft.getEigenschaft( id );

            final EigenschaftWert wert = held.getWert( eigenschaft );

            wert.setBasisstufe( getAttributInt( wertElement, ATTR_BASISSTUFE ));

            wert.setZukaufVorgegeben( getAttributInt(wertElement, ATTR_ZUKAUF));

            wert.setSpezielleErfahrung( getAttributBoolean(
                    wertElement, ATTR_SPEZIELLE_ERFAHRUNG ) );
        }
    }

    /**
     * Wandelt einen String, der ein kommaseparierte Liste von Zahlen enthaelt,
     * in eine Liste von Integer Werten um.
     *
     * @param string String der Form "1,2,3".
     * @return den String als Liste.
     */
    private List< Integer > toIntegerListe( final String string ) {

        final String[] array = string.split( "," );

        final List< Integer > liste = new ArrayList< Integer >( array.length );

        for ( final String wert : array ) {

            liste.add( Integer.valueOf( wert ) );
        }

        return liste;
    }
}
