/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.bausteine.kosten;

import net.n3.nanoxml.IXMLElement;
import de.bernhardjung.dsaprogramm.basis.Held;

/**
 * Die Kosten eines Heldenbausteins.
 *
 * @author Bernhard Jung
 */
public interface Kosten {

    /**
     * @param held der den Baustein bezahlen soll.
     * @return die GP-Kosten die der Held fuer den Baustein zu zahlen hat.
     */
    public int getGpKosten( final Held held );

    /**
     * @return das Objekt als XML-Element.
     */
    public IXMLElement toXml();
}
