/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.gui.meta;

import java.util.Collection;

import de.bernhardjung.dsaprogramm.sonderfertigkeiten.SonderfertigkeitWert;
import de.bernhardjung.dsaprogramm.util.Beobachtbar;

class PanelMetaSonderfertigkeitenWaehlbar extends PanelMetaSonderfertigkeitenAbstrakt {

    PanelMetaSonderfertigkeitenWaehlbar(
            final BeobachtbareListe< SonderfertigkeitWert > liste ) {
        super( liste );
    }

    public void melden( final Beobachtbar b, final Object arg ) {

        if ( BeobachtbareListe.CLEAR.equals( arg ) ) {

            for ( int i = 0, n = werte.size(); i < n ; ++i ) {

                aktualisieren( i );
            }

        } else {

            aktualisieren( ((SonderfertigkeitWert) arg).getSonderfertigkeit() );

        }
    }

    public void setWerte( final Collection< SonderfertigkeitWert > dieWerte ) {

        werte.clear();

        werte.addAll( dieWerte );

        aufbauenBenutzeroberflaeche();
    }

    @Override
    void wertAnAbgewaehlt( final int index, final boolean gewaehlt ) {

        if ( gewaehlt ) {

            gewaehlte.add( werte.get( index ).clone() );

        } else {

            gewaehlte.remove( werte.get( index ) );
        }
    }

}
