/*
    This file is part of the TDE Character Generator (TCG).

    TCG is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    TCG is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with TCG.  If not, see <http://www.gnu.org/licenses/>.
*/
package de.bernhardjung.dsaprogramm.util;

import java.io.File;

public class FileFilter extends javax.swing.filechooser.FileFilter {

    /** Die Dateiendung nach der gefiltern werden soll. */
    public final String dateiendung;

    /**
     * @param dieDateiendung
     *            nach der gefiltert werden soll, z.B. '.xml' oder '.rtf'
     */
    public FileFilter( final String dieDateiendung ) {

        dateiendung = dieDateiendung;
    }

    @Override
    public boolean accept( final File f ) {

        if (f.isDirectory()) {
            return true;
        }

        final String name = f.getName();

        final int index = name.lastIndexOf( "." );

        if (index >= 0) {

            final String endung = name.substring( index );

            return endung.equalsIgnoreCase( dateiendung );

        } else {

            return false;
        }
    }

    @Override
    public String getDescription() {
        return dateiendung;
    }

}
